#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

typedef struct T_STUDENT
{
  struct T_STUDENT	*link;
  int				id;
  int				age;
}STUDENT;

STUDENT *start=NULL;


int addtolist(int id,int age)
{
  STUDENT *newstudent;
  
  newstudent=(STUDENT*)malloc(sizeof(STUDENT));
  if(newstudent!=NULL)
  {
	newstudent->id=id;
	newstudent->age=age;
	newstudent->link=start;
	start=newstudent;
    return(1);
  }
  return(0);
}


STUDENT *getfromlist(int id)
{
  STUDENT *link;

  link=start;
  if(link==NULL)return(NULL);

  while(1)
  {
	if(link->id==id)return(link);
	link=link->link;
	if(link==NULL)return(NULL);
  }
}



int deletefromlist(int id)
{
  STUDENT *link,*parent=NULL;

  link=start;
  if(link==NULL)return(0);

  while(1)
  {
	if(link->id==id)
	{
	  if(parent==NULL)
	  {
		start=link->link;
		free(link);
		return(1);
	  }
	  else
	  {
		parent->link=link->link;
		free(link);
		return(1);
	  }
	}
	parent=link;
	link=link->link;
	if(link==NULL)return(0);
  }
}


int displaylist(void)
{
  STUDENT *link;
  int count=0;

  link=start;
  if(link==NULL)
  {
    printf("No students in the list\n");
	return(0);
  }
  while(1)
  {
	printf("Student = %d  Age = %d\n",link->id,link->age);
	count++;
	link=link->link;
	if(link==NULL)return(count);
  }
}


int freelist(void)
{
  STUDENT *link,*temp;
  int count=0;

  link=start;
  if(link==NULL)return(0);

  while(1)
  {
	count++;
	temp=link;
	link=link->link;
	free(temp);
	if(link==NULL)
	{
	  start=NULL;
	  return(count);
    }  
  }
}

void main(void)
{
  STUDENT *temp;

  printf("Adding five students\n\n");
  addtolist(1,14);
  addtolist(2,12);
  addtolist(3,16);
  addtolist(4,11);
  addtolist(5,13);
  displaylist();
  printf("\nDeleting student 2\n\n");
  deletefromlist(2);
  displaylist();
  printf("\nGetting student 3\n\n");
  temp=getfromlist(3);
  if(temp==NULL)
	printf("Student not found\n");
  else
	printf("Student = %d  Age = %d\n",temp->id,temp->age);
  printf("\nDeleting all students\n\n");
  freelist();
  displaylist();
  getch();
}